javax.ws.rs

## Class NotAuthorizedException

- java.lang.Object
- - java.lang.Throwable
  - - java.lang.Exception
    - - java.lang.RuntimeException
      - - javax.ws.rs.WebApplicationException
        - - javax.ws.rs.ClientErrorException
          - - javax.ws.rs.NotAuthorizedException

- All Implemented Interfaces:
    Serializable

      public class NotAuthorizedException
      extends ClientErrorException

  A runtime exception indicating request authorization failure caused by one of the following scenarios:
  - a client did not send the required authorization credentials to access the requested resource, i.e. `Authorization` HTTP header is missing in the request,
  - or - in case the request already contains the HTTP `Authorization` header - then the exception indicates that authorization has been refused for the credentials contained in the request header.
  Since:
    2.0
  Author:
    Marek Potociar
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `NotAuthorizedException(Object challenge, Object... moreChallenges)` Construct a new "not authorized" exception.
    `NotAuthorizedException(Response response)` Construct a new "not authorized" exception.
    `NotAuthorizedException(Response response, Throwable cause)` Construct a new "not authorized" exception.
    `NotAuthorizedException(String message, Object challenge, Object... moreChallenges)` Construct a new "not authorized" exception.
    `NotAuthorizedException(String message, Response response)` Construct a new "not authorized" exception.
    `NotAuthorizedException(String message, Response response, Throwable cause)` Construct a new "not authorized" exception.
    `NotAuthorizedException(String message, Throwable cause, Object challenge, Object... moreChallenges)` Construct a new "not authorized" exception.
    `NotAuthorizedException(Throwable cause, Object challenge, Object... moreChallenges)` Construct a new "not authorized" exception.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<Object>` | `getChallenges()` Get the list of authorization challenges associated with the exception and applicable to the resource requested by the client.

    - ### Methods inherited from class javax.ws.rs.WebApplicationException

      `getResponse`

    - ### Methods inherited from class java.lang.Throwable

      `addSuppressed, fillInStackTrace, getCause, getLocalizedMessage, getMessage, getStackTrace, getSuppressed, initCause, printStackTrace, printStackTrace, printStackTrace, setStackTrace, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### NotAuthorizedException

          public NotAuthorizedException(Object challenge,
                                Object... moreChallenges)

      Construct a new "not authorized" exception.
      Parameters:
        `challenge` - authorization challenge applicable to the resource requested by the client.
        `moreChallenges` - additional authorization challenge applicable to the requested resource.
      Throws:
        `NullPointerException` - in case the `challenge` parameter is `null`.

    - #### NotAuthorizedException

          public NotAuthorizedException(String message,
                                Object challenge,
                                Object... moreChallenges)

      Construct a new "not authorized" exception.
      Parameters:
        `message` - the detail message (which is saved for later retrieval by the `Throwable.getMessage()` method).
        `challenge` - authorization challenge applicable to the resource requested by the client.
        `moreChallenges` - additional authorization challenge applicable to the requested resource.
      Throws:
        `NullPointerException` - in case the `challenge` parameter is `null`.

    - #### NotAuthorizedException

          public NotAuthorizedException(Response response)

      Construct a new "not authorized" exception.
      Parameters:
        `response` - error response.
      Throws:
        `IllegalArgumentException` - in case the status code set in the response is not HTTP `401`.

    - #### NotAuthorizedException

          public NotAuthorizedException(String message,
                                Response response)

      Construct a new "not authorized" exception.
      Parameters:
        `message` - the detail message (which is saved for later retrieval by the `Throwable.getMessage()` method).
        `response` - error response.
      Throws:
        `IllegalArgumentException` - in case the status code set in the response is not HTTP `401`.

    - #### NotAuthorizedException

          public NotAuthorizedException(Throwable cause,
                                Object challenge,
                                Object... moreChallenges)

      Construct a new "not authorized" exception.
      Parameters:
        `cause` - the underlying cause of the exception.
        `challenge` - authorization challenge applicable to the requested resource.
        `moreChallenges` - additional authorization challenge applicable to the requested resource.

    - #### NotAuthorizedException

          public NotAuthorizedException(String message,
                                Throwable cause,
                                Object challenge,
                                Object... moreChallenges)

      Construct a new "not authorized" exception.
      Parameters:
        `message` - the detail message (which is saved for later retrieval by the `Throwable.getMessage()` method).
        `cause` - the underlying cause of the exception.
        `challenge` - authorization challenge applicable to the requested resource.
        `moreChallenges` - additional authorization challenge applicable to the requested resource.

    - #### NotAuthorizedException

          public NotAuthorizedException(Response response,
                                Throwable cause)

      Construct a new "not authorized" exception.
      Parameters:
        `response` - error response.
        `cause` - the underlying cause of the exception.
      Throws:
        `IllegalArgumentException` - in case the status code set in the response is not HTTP `401`.

    - #### NotAuthorizedException

          public NotAuthorizedException(String message,
                                Response response,
                                Throwable cause)

      Construct a new "not authorized" exception.
      Parameters:
        `message` - the detail message (which is saved for later retrieval by the `Throwable.getMessage()` method).
        `response` - error response.
        `cause` - the underlying cause of the exception.
      Throws:
        `IllegalArgumentException` - in case the status code set in the response is not HTTP `401`.

  - ### Method Detail

    - #### getChallenges

          public List<Object> getChallenges()

      Get the list of authorization challenges associated with the exception and applicable to the resource requested by the client.
      Returns:
        list of authorization challenges applicable to the resource requested by the client.

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.